      PROGRAM HYPERGEOMERIC FUNCTION 2F1
      IMPLICIT REAL*8 (A-H,O-W)
      IMPLICIT COMPLEX*16 (X-Z)
      DIMENSION AY1(2),BX1(2),XWRKSTR(100000)
      COMPLEX*16 HYPGEO
      CHARACTER*8 DE,DB
      COMMON /PARAN/ ZA,ZC,EPSS,NMAX
      EXTERNAL XINTD,XINTN
      ZI = (0.D0,1.D0)
      ZA = - ZI
      ZC = 3 + 0.5D0 * ZI 
C
      NMAX = 55
      EPSS = 1.D-14
C
      NDIM = 2
      MAXPTS = 200000 * NDIM
      LENWRK = (NDIM+2)*(1+MAXPTS/(2**NDIM+2*NDIM**2+2*NDIM+1))
      EPS = 1.D-10
      AY1(1)=0.D0
      AY1(2)=0.D0
      BX1(1)=3.D0
      BX1(2)=3.D0
C
      CALL CPU_TIME(T1)
      CALL TIME(DB)
      MINPTS = 0
      IFAIL = 1
C
      CALL D01FCF1(NDIM,AY1,BX1,MINPTS,MAXPTS,XINTN,EPS,ACC,LENWRK,
     *             XWRKSTR,XI11XY,IFAIL)
C
      CALL CPU_TIME(T2)
      WRITE(*,*) 'FUNCTION ZHYPG2'
      WRITE(*,*) 'VALUE OF 2D INTEGRAL=',XI11XY
C
      T21 = T2 - T1
      CALL TIME(DE)
      WRITE(*,*) ' BEGIN TIME ',DB,' END TIME ',DE,' TOTAL TIME ',T21
C
      CALL TIME(DB)
      MINPTS = 0
      IFAIL = 1
      CALL D01FCF1(NDIM,AY1,BX1,MINPTS,MAXPTS,XINTD,EPS,ACC,LENWRK,
     *             XWRKSTR,XI11YX,IFAIL)
C
      CALL CPU_TIME(T3)
      WRITE(*,*) 'FUNCTION HYPGEO'
      WRITE(*,*) 'VALUE OF 2D INTEGRAL=',XI11YX
C
      T32 = T3 - T2
      CALL TIME(DE)
      WRITE(*,*) ' BEGIN TIME ',DB,' END TIME ',DE,' TOTAL TIME ',T32
C
      WRITE(*,*) 'RATIO OF CALCULATION TIMES=',T32 / T21
C
      END
C
      FUNCTION XINTN(NDIM,V)
      IMPLICIT REAL*8 (A-H,O-W)
      IMPLICIT COMPLEX*16 (X-Z)
      DIMENSION V(NDIM)
      DIMENSION ZGAMM(5),XPOINT(20),XHYPER(40,0:100)
      COMPLEX*16 HYPGEO
      COMMON /PARAN/ ZA,ZC,EPSS,NMAX
      ZI=(0.D0,1.D0)
      ZZ=V(1)+ZI*V(2) !+V(3)**2
      XINTN=ZHYPG2(ZA,ZC,ZZ,NMAX,EPSS)
      XINTN=DEXP(-V(1)-V(2)) * XINTN
      RETURN
      END
C
      FUNCTION XINTD(NDIM,V)
      IMPLICIT REAL*8 (A-H,O-W)
      IMPLICIT COMPLEX*16 (X-Z)
      DIMENSION V(NDIM)
      DIMENSION ZGAMM(5),XPOINT(20),XHYPER(40,0:100)
      COMPLEX*16 HYPGEO
      COMMON /XX/ ZGAMM,XPOINT,XHYPER
      COMMON /PARAN/ ZA,ZC,EPSS,NMAX
      ZI=(0.D0,1.D0)
      ZZ=V(1)+ZI*V(2) !+V(3)**2 
      ZB=2.D0
      XINTN=HYPGEO(ZA,ZB,ZC,ZZ)
      XINTD=XINTN*DEXP(-V(1)-V(2))
      RETURN
      END
C
      FUNCTION ZHYPG2(ZA,ZC,ZZ,NMAX,EPS)
C
C      THIS PROGRAM TO CALCULATE THE HYPERGEOMETRIC 
C                      FUNCTION 2F1(ZA,2;ZC,ZZ).
C
      IMPLICIT REAL*8 (A-H,O-W)
      IMPLICIT COMPLEX*16 (X-Z)
      DIMENSION ZGAMM(5),XPOINT(20),XHYPER(40,0:100)
      COMMON /XX/ ZGAMM,XPOINT,XHYPER
      LOGICAL FIRST
      SAVE FIRST
      DATA FIRST / .TRUE. /
C
      IF( FIRST ) THEN
         FIRST = .FALSE.
         CALL ZGAMMA(ZA,ZC,ZGAMM,XPOINT,XHYPER,NMAX)
      END IF
C       
      Z1=1-ZZ
C
      IF (CDABS(ZZ) .LE. 0.5D0) THEN
C
        ZHYPG2=ZSUM(ZA,ZC,ZZ,NMAX,EPS)
C
      ELSE IF (CDABS(ZZ) .GE. 2.D0) THEN
C
        ZZ1=1.D0/ZZ
        ZGAM=ZGAMM(2)*ZGAMM(3)/ZGAMM(4)
        ZHYPG2=ZGAM*(-ZZ)**(-ZA)*(1-ZZ1)**(ZC-ZA-1)
        ZHYPG2=ZHYPG2*(1-(ZA-ZC+1)/(ZA-1)*ZZ1/(ZZ1-1))
        ZA1=3-ZC
        ZC1=3-ZA
        ZEX=ZSUM(ZA1,ZC1,ZZ1,NMAX,EPS)*(-ZZ)**(-2)
        ZHYPG2=ZHYPG2+ZEX*(ZC-1)*(ZC-2)/(ZA-1)/(ZA-2)
C
      ELSE IF (CDABS(1-ZZ) .LE. 0.5D0) THEN
C
        ZGAM=ZGAMM(2)*ZGAMM(5)/ZGAMM(1)
        ZHYPG2=ZGAM*(Z1)**(ZC-ZA-2)*(1-Z1)**(2-ZC)
        ZHYPG2=ZHYPG2*(1-(ZC-2)/(ZC-ZA-1)*Z1/(Z1-1))
        ZA1=ZA
        ZC1=ZA+3-ZC
        ZEX=ZSUM(ZA1,ZC1,Z1,NMAX,EPS)
        ZHYPG2=ZHYPG2+ZEX*(ZC-1)*(ZC-2)/(ZC-ZA-1)/(ZC-ZA-2)
          IF (CDABS(ZHYPG2).GT.1D5) WRITE(*,*) ZZ,ZHYPG2
C
      ELSE IF (CDABS(1-ZZ) .GE. 2.D0) THEN
C
        ZZ1=1.D0/Z1
        ZGAM=ZGAMM(2)*ZGAMM(3)/ZGAMM(4)
        ZHYPG2=ZGAM*(Z1)**(-ZA)*(1-ZZ1)**(2-ZC)
        ZHYPG2=ZHYPG2*(1-(ZC-2)/(ZA-1)*ZZ1/(ZZ1-1))
        ZA1=ZC-ZA
        ZC1=3-ZA
        ZEX=ZSUM(ZA1,ZC1,ZZ1,NMAX,EPS)*(Z1)**(-2)
        ZHYPG2=ZHYPG2+ZEX*(ZC-1)*(ZC-2)/(ZA-1)/(ZA-2)
C
      ELSE IF (CDABS(1-1.D0/ZZ) .LE. 0.5D0) THEN
C
        ZZ1=1-1.D0/ZZ
        ZGAM=ZGAMM(2)*ZGAMM(5)/ZGAMM(1)
        ZHYPG2=ZGAM*(Z1)**(ZC-ZA-2)*ZZ**(ZA-ZC)*(1-ZZ1)**(ZA-1)
        ZHYPG2=ZHYPG2*(1-(1-ZA)/(ZC-ZA-1)*ZZ1/(ZZ1-1))
        ZA1=3-ZC
        ZC1=ZA-ZC+3
        ZEX=ZSUM(ZA1,ZC1,ZZ1,NMAX,EPS)*(1-ZZ1)**(2-ZA)*ZZ**(-ZA)
        ZHYPG2=ZHYPG2+ZEX*(ZC-1)*(ZC-2)/(ZC-ZA-1)/(ZC-ZA-2)
C
      ELSE IF (CDABS(1-1.D0/ZZ) .GE. 2.D0) THEN
C
        ZZ1=-ZZ/Z1
        ZA1=ZC-ZA
        ZC1=ZC
        ZHYPG2=ZSUM(ZA1,ZC1,ZZ1,NMAX,EPS)*Z1**(-2)
C
      ELSE
C
        DMINOLD=0.5D0
        JNUM=1
        INUM=0
        IF (DIMAG(ZZ) .LT. 0.D0) JNUM=11
C
          DO I=JNUM , 9 + JNUM
            DMINNEW=DMIN1(DMINOLD,CDABS(ZZ-XPOINT(I)))
            IF (DMINNEW .LT. DMINOLD) THEN
              DMINOLD=DMINNEW
              INUM=I
            END IF
          END DO
C
        IF (INUM .EQ. 0) THEN
C
          DMINOLD=DSQRT(5.D0) / 4
          DMINNEW=DMIN1(DMINOLD,CDABS(ZZ))
          IF (DMINNEW .LT. DMINOLD) THEN
            DMINOLD=DMINNEW
            INUM=22
          END IF
          DMINNEW=DMIN1(DMINOLD,CDABS(ZZ-1))
          IF (DMINNEW .LT. DMINOLD) THEN
            DMINOLD=DMINNEW
            INUM=23
          END IF
C
        END IF
C
        IF (INUM .EQ. 0 .AND. DIMAG(ZZ) .GT. 0.D0) THEN
C
          DMINNEW=DMIN1(DMINOLD,CDABS(ZZ-XPOINT(8)))
          IF (DMINNEW .LT. DMINOLD) THEN
            DMINOLD=DMINNEW
            INUM=8
          END IF
          DMINNEW=DMIN1(DMINOLD,CDABS(ZZ-XPOINT(9)))
          IF (DMINNEW .LT. DMINOLD) THEN
            DMINOLD=DMINNEW
            INUM=9
          END IF
C
        ELSE IF (INUM .EQ. 0 .AND. DIMAG(ZZ) .LT. 0.D0) THEN
C
          DMINNEW=DMIN1(DMINOLD,CDABS(ZZ-XPOINT(12)))
          IF (DMINNEW .LT. DMINOLD) THEN
            DMINOLD=DMINNEW
            INUM=12
          END IF
          DMINNEW=DMIN1(DMINOLD,CDABS(ZZ-XPOINT(13)))
          IF (DMINNEW .LT. DMINOLD) THEN
            DMINOLD=DMINNEW
            INUM=13
          END IF
C
        END IF
C
        IF (INUM .NE. 22 .AND. INUM .NE. 23) THEN
C
          IF (CDABS(1 - XPOINT(INUM)) .GT. 1) THEN
C
             Z1=ZZ-XPOINT(INUM)
             ZHYPG2=XHYPER(INUM,0)
             ZEX=1.D0
             DO I=1 , NMAX
               ZEX=ZEX * Z1
               ZHYPG2=ZHYPG2 + XHYPER(INUM,I) * ZEX
               IF (CDABS(XHYPER(INUM,I) * ZEX) .LT. EPS) RETURN
             END DO
C
           ELSE IF (CDABS(XPOINT(INUM)) .GT. 1) THEN
C
             Z1=ZZ - XPOINT(INUM)
             ZHYPG2=XHYPER(INUM + 20,0)
             ZEX=1.D0
             DO I=1 , NMAX
               ZEX=- ZEX * Z1
               ZHYPG2=ZHYPG2 + XHYPER(INUM + 20,I) * ZEX
               IF (CDABS(XHYPER(INUM + 20,I) * ZEX) .LT. EPS) GO TO 123
             END DO
123          ZHYPG2=ZHYPG2 * (ZC - 1) * (ZC - 2)
             ZHYPG2=ZHYPG2 / (ZC - ZA - 1) / (ZC - ZA - 2)
             ZGAM=ZGAMM(2)*ZGAMM(5)/ZGAMM(1)
             ZHYPG=ZGAM*(1-ZZ)**(ZC-ZA-2)*(ZZ)**(2-ZC)
             ZHYPG=ZHYPG*(1-(ZC-2)/(ZC-ZA-1)*(ZZ-1)/ZZ)
             ZHYPG2=ZHYPG2 + ZHYPG
C
           END IF
C
        ELSE IF (INUM .EQ. 22) THEN
C
          ZHYPG2=ZSUM(ZA,ZC,ZZ,NMAX,EPS)
C
        ELSE IF (INUM .EQ. 23) THEN
C
          ZGAM=ZGAMM(2)*ZGAMM(5)/ZGAMM(1)
          ZHYPG2=ZGAM*(Z1)**(ZC-ZA-2)*(1-Z1)**(2-ZC)
          ZHYPG2=ZHYPG2*(1-(ZC-2)/(ZC-ZA-1)*Z1/(Z1-1))
          ZA1=ZA
          ZC1=ZA+3-ZC
          ZEX=ZSUM(ZA1,ZC1,Z1,NMAX,EPS)
          ZHYPG2=ZHYPG2+ZEX*(ZC-1)*(ZC-2)/(ZC-ZA-1)/(ZC-ZA-2)
C
        END IF
C
      END IF
      RETURN
      END
C
      FUNCTION ZSUM(ZA,ZC,ZZ,NMAX,EPS)
      IMPLICIT REAL*8 (A-H,O-W)
      IMPLICIT COMPLEX*16 (X-Z)
      ZSUM=1.D0
      ZFAC=1.D0
      DO I=1,NMAX
        ZFAC=ZFAC*(ZA+I-1)/(ZC+I-1)*ZZ
        ZSUM=ZSUM+ZFAC*(I+1)
        IF (CDABS(ZFAC / ZSUM) .LT. EPS) RETURN
      END DO
      WRITE(*,*) 'CONVERGENCE FAILURE IN ZSUM',CDABS(ZFAC)
      RETURN
      END
C
      SUBROUTINE ZGAMMA(ZA,ZC,ZGAM1,XPOINT,XHYPER,NMAX)
      IMPLICIT REAL*8 (A-H,O-W)
      IMPLICIT COMPLEX*16 (X-Z)
      DIMENSION ZGAM1(5),XPOINT(20),XHYPER(40,0:NMAX),XDR(0:NMAX)
      DOUBLECOMPLEX HYPGEO
C
      ZI = (0.D0,1.D0)
      ZB=2.D0
C
      CALL CGAMA(DREAL(ZA       ),DIMAG(ZA       ),1,GR,GI)
      ZGAM1(1)=DCMPLX(GR,GI) ! G(A)
      CALL CGAMA(DREAL(ZC       ),DIMAG(ZC       ),1,GR,GI)
      ZGAM1(2)=DCMPLX(GR,GI) ! G(C)
      CALL CGAMA(DREAL(ZB-ZA    ),DIMAG(ZB-ZA    ),1,GR,GI)
      ZGAM1(3)=DCMPLX(GR,GI) ! G(B-A)
      CALL CGAMA(DREAL(ZC-ZA    ),DIMAG(ZC-ZA    ),1,GR,GI)
      ZGAM1(4)=DCMPLX(GR,GI) ! G(C-A)
      CALL CGAMA(DREAL(ZA+ZB-ZC ),DIMAG(ZA+ZB-ZC ),1,GR,GI)
      ZGAM1(5)=DCMPLX(GR,GI) ! G(A+B-C)
C
      XPOINT(1 )= 0.5D0+2.0D0*ZI
      XPOINT(2 )= 0.0D0+1.5D0*ZI
      XPOINT(3 )= 1.0D0+1.5D0*ZI
      XPOINT(4 )=-0.5D0+1.0D0*ZI
      XPOINT(5 )= 0.5D0+1.0D0*ZI
      XPOINT(6 )= 1.5D0+1.0D0*ZI
      XPOINT(7 )=-1.0D0+0.5D0*ZI
      XPOINT(8 )= 0.0D0+0.5D0*ZI
      XPOINT(9 )= 1.0D0+0.5D0*ZI
      XPOINT(10)= 2.0D0+0.5D0*ZI
C
      DO I = 1 , 10
        XPOINT(21-I)=DCONJG(XPOINT(I))
      END DO
C
CX      XPOINT(22)= 0.0D0+0.0D0*ZI
CX      XPOINT(23)= 1.0D0+0.0D0*ZI
C
      DO I = 1 , 20
        XDR(0)=HYPGEO(ZA,ZB,ZC,XPOINT(I))
        XDR(1)=ZA*ZB/ZC*HYPGEO(ZA+1,ZB+1,ZC+1,XPOINT(I))
        CALL DRHYP(ZA,ZB,ZC,XPOINT(I),XDR,NMAX)
        DO J = 0 , NMAX
          XHYPER(I,J)=XDR(J)
        END DO
      END DO
C
      ZA1 = ZA
      ZB1 = ZB
      ZC1 = ZA - ZC + ZB + 1
      DO I = 1 , 20
        XDR(0)=HYPGEO(ZA1,ZB1,ZC1,1 - XPOINT(I))
        XDR(1)=ZA1*ZB1/ZC1*HYPGEO(ZA1 + 1,ZB1 + 1,ZC1 + 1,1 - XPOINT(I))
        CALL DRHYP(ZA1,ZB1,ZC1,1 - XPOINT(I),XDR,NMAX)
        DO J = 0 , NMAX
          XHYPER(I + 20,J)=XDR(J)
        END DO
      END DO
      RETURN
      END
C
      SUBROUTINE DRHYP(ZA,ZB,ZC,ZX,XDR,NMAX)
      IMPLICIT REAL*8 (A-H,O-W)
      IMPLICIT COMPLEX*16 (X-Z)
      DIMENSION XDR(0:NMAX)
C
      ZD=ZA+ZB+1
      ZZ=ZX-ZX*ZX
      DO N = 0 , NMAX - 2
      XDR(N+2)=(ZC-ZD*ZX+N*(1-2*ZX))*XDR(N+1)/(N+2)
      XDR(N+2)=XDR(N+2)-((N-1)*N+N*ZD+ZA*ZB)*XDR(N)/(N+1)/(N+2)
      XDR(N+2)=-XDR(N+2)/ZZ
      END DO
      RETURN
      END
C
      SUBROUTINE CGAMA(X,Y,KF,GR,GI)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(10)
      PI=3.141592653589793D0
      DATA A/8.333333333333333D-02,-2.777777777777778D-03,
     &       7.936507936507937D-04,-5.952380952380952D-04,
     &       8.417508417508418D-04,-1.917526917526918D-03,
     &       6.410256410256410D-03,-2.955065359477124D-02,
     &       1.796443723688307D-01,-1.39243221690590D+00/
      IF (Y.EQ.0.0D0.AND.X.EQ.INT(X).AND.X.LE.0.0D0) THEN
         GR=1.0D+300
         GI=0.0D0
         RETURN
      ELSE IF (X.LT.0.0D0) THEN
         X1=X
         Y1=Y
         X=-X
         Y=-Y
      ENDIF
      X0=X
      IF (X.LE.7.0) THEN
         NA=INT(7-X)
         X0=X+NA
      ENDIF
      Z1=DSQRT(X0*X0+Y*Y)
      TH=DATAN(Y/X0)
      GR=(X0-.5D0)*DLOG(Z1)-TH*Y-X0+0.5D0*DLOG(2.0D0*PI)
      GI=TH*(X0-0.5D0)+Y*DLOG(Z1)-Y
      DO 10 K=1,10
         T=Z1**(1-2*K)
         GR=GR+A(K)*T*DCOS((2.0D0*K-1.0D0)*TH)
10       GI=GI-A(K)*T*DSIN((2.0D0*K-1.0D0)*TH)
      IF (X.LE.7.0) THEN
         GR1=0.0D0
         GI1=0.0D0
         DO 15 J=0,NA-1
            GR1=GR1+.5D0*DLOG((X+J)**2+Y*Y)
15          GI1=GI1+DATAN(Y/(X+J))
         GR=GR-GR1
         GI=GI-GI1
      ENDIF
      IF (X1.LT.0.0D0) THEN
         Z1=DSQRT(X*X+Y*Y)
         TH1=DATAN(Y/X)
         SR=-DSIN(PI*X)*DCOSH(PI*Y)
         SI=-DCOS(PI*X)*DSINH(PI*Y)
         Z2=DSQRT(SR*SR+SI*SI)
         TH2=DATAN(SI/SR)
         IF (SR.LT.0.0D0) TH2=PI+TH2
         GR=DLOG(PI/(Z1*Z2))-GR
         GI=-TH1-TH2-GI
         X=X1
         Y=Y1
      ENDIF
      IF (KF.EQ.1) THEN
         G0=DEXP(GR)
         GR=G0*DCOS(GI)
         GI=G0*DSIN(GI)
      ENDIF
      RETURN
      END
C
      FUNCTION HYPGEO(A,B,C,Z)
      COMPLEX*16 HYPGEO,A,B,C,Z
      DOUBLE PRECISION EPS
      PARAMETER (EPS=1.D-14)
CU    USES BSSTEP,HYPDRV,HYPSER,ODEINT
      INTEGER KMAX,NBAD,NOK
      EXTERNAL BSSTEP,HYPDRV
      COMPLEX*16 Z0,DZ,AA,BB,CC,Y(2)
      COMMON /HYPG/ AA,BB,CC,Z0,DZ
      COMMON /PATH/ KMAX
      REAL*8 RY(4)
      KMAX=0
      IF (DREAL(Z)**2+DIMAG(Z)**2.LE.0.25D0) THEN
        CALL HYPSER(A,B,C,Z,HYPGEO,Y(2))
        RETURN
      ELSE IF (DREAL(Z).LT.0.D0) THEN
        Z0=DCMPLX(-0.5D0,0.D0)
      ELSE IF (DREAL(Z).LE.1.0D0) THEN
        Z0=DCMPLX(0.5D0,0.D0)
      ELSE
        Z0=DCMPLX(0.D0,SIGN(0.5D0,DIMAG(Z)))
      ENDIF
      AA=A
      BB=B
      CC=C
      DZ=Z-Z0
      CALL HYPSER(AA,BB,CC,Z0,Y(1),Y(2))
      RY(1)=DREAL(Y(1))
      RY(2)=DIMAG(Y(1))
      RY(3)=DREAL(Y(2))
      RY(4)=DIMAG(Y(2))
      CALL ODEINT(RY,4,0.D0,1.D0,EPS,.1D0,.0001D0,NOK,NBAD,HYPDRV
     *  ,BSSTEP)
      HYPGEO=RY(1) +(0.D0,1D0)*RY(2)
      RETURN
      END
C
      SUBROUTINE HYPDRV(S,Y,DYDS)
      DOUBLE PRECISION S
      COMPLEX*16 Y(2),DYDS(2),AA,BB,CC,Z0,DZ,Z
      COMMON /HYPG/ AA,BB,CC,Z0,DZ
      Z=Z0+S*DZ
      DYDS(1)=Y(2)*DZ
      DYDS(2)=(AA*BB*Y(1)-(CC-(AA+BB+1.D0)*Z)*Y(2))*DZ/(Z*(1.D0-Z))
      RETURN
      END
C
      SUBROUTINE HYPSER(A,B,C,Z,SERIES,DERIV)
      INTEGER N
      COMPLEX*16 A,B,C,Z,SERIES,DERIV,AA,BB,CC,FAC,TEMP
      DERIV=DCMPLX(0.D0,0.D0)
      FAC=DCMPLX(1.D0,0.D0)
      TEMP=FAC
      AA=A
      BB=B
      CC=C
      DO 11 N=1,1000
        FAC=((AA*BB)/CC)*FAC
        DERIV=DERIV+FAC
        FAC=FAC*Z/N
        SERIES=TEMP+FAC
        IF (SERIES.EQ.TEMP) RETURN
        TEMP=SERIES
        AA=AA+1.D0
        BB=BB+1.D0
        CC=CC+1.D0
11    CONTINUE
      WRITE(*,*) 'CONVERGENCE FAILURE IN HYPSER'
      END
C
      SUBROUTINE BSSTEP(Y,DYDX,NV,X,HTRY,EPS,YSCAL,HDID,HNEXT,DERIVS)
      INTEGER NV,NMAX,KMAXX,IMAX
      DOUBLE PRECISION EPS,HDID,HNEXT,HTRY,X,DYDX(NV),Y(NV),YSCAL(NV)
     *,SAFE1,SAFE2,REDMAX,REDMIN,TINY,SCALMX
      PARAMETER (NMAX=50,KMAXX=8,IMAX=KMAXX+1,SAFE1=.25D0,SAFE2=.7D0,
     *REDMAX=1.D-5,REDMIN=.7D0,TINY=1.D-30,SCALMX=.1D0)
CU    USES DERIVS,MMID,PZEXTR
      INTEGER I,IQ,K,KK,KM,KMAX,KOPT,NSEQ(IMAX)
      DOUBLE PRECISION EPS1,EPSOLD,ERRMAX,FACT,H,RED,SCALE,WORK,WRKMIN
     *,XEST,XNEW,A(IMAX),ALF(KMAXX,KMAXX),ERR(KMAXX),YERR(NMAX),
     *YSAV(NMAX),YSEQ(NMAX)
      LOGICAL FIRST,REDUCT
      SAVE A,ALF,EPSOLD,FIRST,KMAX,KOPT,NSEQ,XNEW
      EXTERNAL DERIVS
      DATA FIRST/.TRUE./,EPSOLD/-1.D0/
      DATA NSEQ /2,4,6,8,10,12,14,16,18/
      IF(EPS.NE.EPSOLD)THEN
        HNEXT=-1.D29
        XNEW=-1.D29
        EPS1=SAFE1*EPS
        A(1)=NSEQ(1)+1
        DO 11 K=1,KMAXX
          A(K+1)=A(K)+NSEQ(K+1)
11      CONTINUE
        DO 13 IQ=2,KMAXX
         DO 12 K=1,IQ-1
          ALF(K,IQ)=EPS1**((A(K+1)-A(IQ+1))/((A(IQ+1)-A(1)+1.D0)*(2*K+
     *1)))
12        CONTINUE
13      CONTINUE
        EPSOLD=EPS
        DO 14 KOPT=2,KMAXX-1
          IF(A(KOPT+1).GT.A(KOPT)*ALF(KOPT-1,KOPT))GOTO 1
14      CONTINUE
1       KMAX=KOPT
      ENDIF
      H=HTRY
      DO 15 I=1,NV
        YSAV(I)=Y(I)
15    CONTINUE
      IF(H.NE.HNEXT.OR.X.NE.XNEW)THEN
        FIRST=.TRUE.
        KOPT=KMAX
      ENDIF
      REDUCT=.FALSE.
2     DO 17 K=1,KMAX
        XNEW=X+H
        IF(XNEW.EQ.X) WRITE(*,*) 'STEP SIZE UNDERFLOW IN BSSTEP'
        CALL MMID(YSAV,DYDX,NV,X,H,NSEQ(K),YSEQ,DERIVS)
        XEST=(H/NSEQ(K))**2
        CALL PZEXTR(K,XEST,YSEQ,Y,YERR,NV)
        IF(K.NE.1)THEN
          ERRMAX=TINY
          DO 16 I=1,NV
            ERRMAX=MAX(ERRMAX,ABS(YERR(I)/YSCAL(I)))
16        CONTINUE
          ERRMAX=ERRMAX/EPS
          KM=K-1
          ERR(KM)=(ERRMAX/SAFE1)**(1.D0/(2*KM+1))
        ENDIF
        IF(K.NE.1.AND.(K.GE.KOPT-1.OR.FIRST))THEN
          IF(ERRMAX.LT.1.D0)GOTO 4
          IF(K.EQ.KMAX.OR.K.EQ.KOPT+1)THEN
            RED=SAFE2/ERR(KM)
            GOTO 3
          ELSE IF(K.EQ.KOPT)THEN
            IF(ALF(KOPT-1,KOPT).LT.ERR(KM))THEN
              RED=1.D0/ERR(KM)
              GOTO 3
            ENDIF
          ELSE IF(KOPT.EQ.KMAX)THEN
            IF(ALF(KM,KMAX-1).LT.ERR(KM))THEN
              RED=ALF(KM,KMAX-1)*SAFE2/ERR(KM)
              GOTO 3
            ENDIF
          ELSE IF(ALF(KM,KOPT).LT.ERR(KM))THEN
            RED=ALF(KM,KOPT-1)/ERR(KM)
            GOTO 3
          ENDIF
        ENDIF
17    CONTINUE
3     RED=MIN(RED,REDMIN)
      RED=MAX(RED,REDMAX)
      H=H*RED
      REDUCT=.TRUE.
      GOTO 2
4     X=XNEW
      HDID=H
      FIRST=.FALSE.
      WRKMIN=1.D35
      DO 18 KK=1,KM
        FACT=MAX(ERR(KK),SCALMX)
        WORK=FACT*A(KK+1)
        IF(WORK.LT.WRKMIN)THEN
          SCALE=FACT
          WRKMIN=WORK
          KOPT=KK+1
        ENDIF
18    CONTINUE
      HNEXT=H/SCALE
      IF(KOPT.GE.K.AND.KOPT.NE.KMAX.AND..NOT.REDUCT)THEN
        FACT=MAX(SCALE/ALF(KOPT-1,KOPT),SCALMX)
        IF(A(KOPT+1)*FACT.LE.WRKMIN)THEN
          HNEXT=H/FACT
          KOPT=KOPT+1
        ENDIF
      ENDIF
      RETURN
      END
C
      SUBROUTINE ODEINT(YSTART,NVAR,X1,X2,EPS,H1,HMIN,NOK,NBAD,DERIVS,
     *RKQS)
      INTEGER NBAD,NOK,NVAR,KMAXX,MAXSTP,NMAX
      DOUBLE PRECISION EPS,H1,HMIN,X1,X2,YSTART(NVAR),TINY
      EXTERNAL DERIVS,RKQS
      PARAMETER (MAXSTP=10000,NMAX=50,KMAXX=200,TINY=1.D-30)
      INTEGER I,KMAX,KOUNT,NSTP
      DOUBLE PRECISION DXSAV,H,HDID,HNEXT,X,XSAV,DYDX(NMAX),XP(KMAXX),Y
     *(NMAX),YP(NMAX,KMAXX),YSCAL(NMAX)
      COMMON /PATH/ KMAX,KOUNT,DXSAV,XP,YP
      X=X1
      H=SIGN(H1,X2-X1)
      NOK=0
      NBAD=0
      KOUNT=0
      DO 11 I=1,NVAR
        Y(I)=YSTART(I)
11    CONTINUE
      IF (KMAX.GT.0) XSAV=X-2.D0*DXSAV
      DO 16 NSTP=1,MAXSTP
        CALL DERIVS(X,Y,DYDX)
        DO 12 I=1,NVAR
          YSCAL(I)=ABS(Y(I))+ABS(H*DYDX(I))+TINY
12      CONTINUE
        IF(KMAX.GT.0)THEN
          IF(ABS(X-XSAV).GT.ABS(DXSAV)) THEN
            IF(KOUNT.LT.KMAX-1)THEN
              KOUNT=KOUNT+1
              XP(KOUNT)=X
              DO 13 I=1,NVAR
                YP(I,KOUNT)=Y(I)
13            CONTINUE
              XSAV=X
            ENDIF
          ENDIF
        ENDIF
        IF((X+H-X2)*(X+H-X1).GT.0.D0) H=X2-X
        CALL RKQS(Y,DYDX,NVAR,X,H,EPS,YSCAL,HDID,HNEXT,DERIVS)
        IF(HDID.EQ.H)THEN
          NOK=NOK+1
        ELSE
          NBAD=NBAD+1
        ENDIF
        IF((X-X2)*(X2-X1).GE.0.D0)THEN
          DO 14 I=1,NVAR
            YSTART(I)=Y(I)
14        CONTINUE
          IF(KMAX.NE.0)THEN
            KOUNT=KOUNT+1
            XP(KOUNT)=X
            DO 15 I=1,NVAR
              YP(I,KOUNT)=Y(I)
15          CONTINUE
          ENDIF
          RETURN
        ENDIF
CX        IF(ABS(HNEXT).LT.HMIN) WRITE(*,*) 
CX     *'STEPSIZE SMALLER THAN MINIMUM IN ODEINT'
        H=HNEXT
16    CONTINUE
      WRITE(*,*) 'TOO MANY STEPS IN ODEINT'
      RETURN
      END
C
      SUBROUTINE MMID(Y,DYDX,NVAR,XS,HTOT,NSTEP,YOUT,DERIVS)
      INTEGER NSTEP,NVAR,NMAX
      DOUBLE PRECISION HTOT,XS,DYDX(NVAR),Y(NVAR),YOUT(NVAR)
      EXTERNAL DERIVS
      PARAMETER (NMAX=50)
      INTEGER I,N
      DOUBLE PRECISION H,H2,SWAP,X,YM(NMAX),YN(NMAX)
      H=HTOT/NSTEP
      DO 11 I=1,NVAR
        YM(I)=Y(I)
        YN(I)=Y(I)+H*DYDX(I)
11    CONTINUE
      X=XS+H
      CALL DERIVS(X,YN,YOUT)
      H2=2.D0*H
      DO 13 N=2,NSTEP
        DO 12 I=1,NVAR
          SWAP=YM(I)+H2*YOUT(I)
          YM(I)=YN(I)
          YN(I)=SWAP
12      CONTINUE
        X=X+H
        CALL DERIVS(X,YN,YOUT)
13    CONTINUE
      DO 14 I=1,NVAR
        YOUT(I)=0.5D0*(YM(I)+YN(I)+H*YOUT(I))
14    CONTINUE
      RETURN
      END
C
      SUBROUTINE PZEXTR(IEST,XEST,YEST,YZ,DY,NV)
      INTEGER IEST,NV,IMAX,NMAX
      DOUBLE PRECISION XEST,DY(NV),YEST(NV),YZ(NV)
      PARAMETER (IMAX=13,NMAX=50)
      INTEGER J,K1
      DOUBLE PRECISION DELTA,F1,F2,Q,D(NMAX),QCOL(NMAX,IMAX),X(IMAX)
      SAVE QCOL,X
      X(IEST)=XEST
      DO 11 J=1,NV
        DY(J)=YEST(J)
        YZ(J)=YEST(J)
11    CONTINUE
      IF(IEST.EQ.1) THEN
        DO 12 J=1,NV
          QCOL(J,1)=YEST(J)
12      CONTINUE
      ELSE
        DO 13 J=1,NV
          D(J)=YEST(J)
13      CONTINUE
        DO 15 K1=1,IEST-1
          DELTA=1.D0/(X(IEST-K1)-XEST)
          F1=XEST*DELTA
          F2=X(IEST-K1)*DELTA
          DO 14 J=1,NV
            Q=QCOL(J,K1)
            QCOL(J,K1)=DY(J)
            DELTA=D(J)-Q
            DY(J)=F1*DELTA
            D(J)=F2*DELTA
            YZ(J)=YZ(J)+DY(J)
14        CONTINUE
15      CONTINUE
        DO 16 J=1,NV
          QCOL(J,IEST)=DY(J)
16      CONTINUE
      ENDIF
      RETURN
      END
C
      SUBROUTINE D01FCF1(NDIM, A, B, MINPTS, MAXPTS, FUNCTN, EPS,ACC,
     * LENWRK, WRKSTR, FINVAL, IFAIL)
C     MARK 8 RELEASE. NAG COPYRIGHT 1979.
C
C     ADAPTIVE MULTIDIMENSIONAL INTEGRATION SUBROUTINE
C
C     *********  PARAMETERS FOR D01FCF  ****************************
C
C      INPUT PARAMETERS
C
C     NDIM    INTEGER NUMBER OF VARIABLES, MUST EXCEED 1 BUT
C             NOT EXCEED 15.
C
C     A       REAL ARRAY OF LOWER LIMITS, WITH DIMENSION NDIM
C
C     B       REAL ARRAY OF UPPER LIMITS, WITH DIMENSION NDIM
C
C     MINPTS  INTEGER MINIMUM NUMBER OF INTEGRAND VALUES TO BE
C             ALLOWED, WHICH MUST NOT EXCEED MAXPTS.
C
C     MAXPTS  INTEGER MAXIMUM NUMBER OF INTEGRAND VALUES TO BE
C             ALLOWED, WHICH MUST BE AT LEAST
C             2**NDIM+2*NDIM**2+2*NDIM+1.
C
C     FUNCTN  EXTERNALLY DECLARED USER DEFINED REAL FUNCTION
C             INTEGRAND. IT MUST HAVE PARAMETERS (NDIM,Z),
C             WHERE Z IS A REAL ARRAY OF DIMENSION NDIM.
C
C     EPS     REAL REQUIRED RELATIVE ACCURACY, MUST BE GREATER
C             THAN ZERO
C
C     LENWRK  INTEGER LENGTH OF ARRAY WRKSTR, MUST BE AT LEAST
C             2*NDIM+4.
C
C     IFAIL   INTEGER NAG FAILURE PARAMETER
C             IFAIL=0 FOR HARD FAIL
C             IFAIL=1 FOR SOFT FAIL
C
C      OUTPUT PARAMETERS
C
C     MINPTS  INTEGER NUMBER OF INTEGRAND VALUES USED BY THE
C             ROUTINE
C
C     WRKSTR  REAL ARRAY OF WORKING STORAGE OF DIMENSION (LENWRK).
C
C     ACC     REAL ESTIMATED RELATIVE ACCURACY OF FINVAL
C
C     FINVAL  REAL ESTIMATED VALUE OF INTEGRAL
C
C     IFAIL   IFAIL=0 FOR NORMAL EXIT, WHEN ESTIMATED RELATIVE
C                  LESS INTEGACCURACY RAND VALUES USED.
C
C          IFAIL=1 IF NDIM.LT.2, NDIM.GT.15, MINPTS.GT.MAXPTS,
C                  MAXPTS.LT.2**NDIM+2*NDIM*(NDIM+1)+1, EPS.LE.0
C                  OR LENWRK.LT.2*NDIM+4.
C
C          IFAIL=2 IF MAXPTS WAS TOO SMALL FOR D01FCF TO OBTAIN THE
C                  REQUIRED RELATIVE ACCURACY EPS.  IN THIS
C                  CASE D01FCF RETURNS A VALUE OF FINVAL
C                  WITH ESTIMATED RELATIVE ACCURACY ACC.
C
C          IFAIL=3 IF LENWRK TOO SMALL FOR MAXPTS INTEGRAND
C                  VALUES.  IN THIS CASE D01FCF RETURNS A
C                  VALUE OF FINVAL WITH ESTIMATED ACCURACY
C                  ACC USING THE WORKING STORAGE
C                  AVAILABLE, BUT ACC WILL BE GREATER
C                  THAN EPS.
C
C     **************************************************************
C
C     .. SCALAR ARGUMENTS ..
      DOUBLE PRECISION EPS,  ACC
      INTEGER IFAIL, LENWRK, MAXPTS, MINPTS, NDIM
C     .. ARRAY ARGUMENTS ..
      DOUBLE PRECISION A(NDIM), B(NDIM)
C     .. FUNCTION ARGUMENTS ..
      DOUBLECOMPLEX FUNCTN, F1, F2, F3, F4, SUM1, SUM2, SUM3, SUM4, SUM5
      DOUBLECOMPLEX DF1, DF2,RGNVAL,RGNVLT,RGNCMP,FINVAL, WRKSTR(LENWRK)

C     ..
C     .. LOCAL SCALARS ..
C$P 1
      DOUBLE PRECISION SRNAME
      DOUBLE PRECISION ABSERR, DIFMAX,  HALF,	RGNVOL,
     * LAMDA2,LAMDA4, LAMDA5, ONE, RATIO, RGNERR, RGNERT, RLNDIM,
     *  TWO,
     *TWONDM, WEIT1, WEIT2, WEIT3, WEIT4, WEIT5, WEITP1, WEITP2,WEITP3,
     * WEITP4, ZERO
      INTEGER DVAXES, DVAXIS, DVFLAG, FUNCLS, IERROR, J, K, MAXAXS,
     *MXRGNS, POINTR, RGNCLS, RULCLS, SBRGNS, SUBRGN, SUBTMP,TPONTP,
     * TPONTR
C     .. LOCAL ARRAYS ..
      DOUBLE PRECISION CENTER(15), DIF(15), OLDCNT(15), WIDTH(15), Z(15)
      INTEGER DVCNTL(15), DVCNTR(15)
C     .. FUNCTION REFERENCES ..
      DOUBLE PRECISION DSQRT, X02AAF
C     *** IMPLEMENTATION DEPENDENT DECLARATION ***
C     DOUBLE PRECISION DFLOAT
      INTEGER P01AAF, X02BBF
C     ..
      DATA SRNAME /8H D01FCF /
      DATA ZERO, ONE, TWO, HALF /0.0D0, 1.0D0, 2.0D0, 0.5D0/
C
C       SUBROUTINE INITIALISATION AND PARAMETER CHECKING
C
      IF (NDIM.LT.2 .OR. NDIM.GT.15) GO TO 560
      IF (MINPTS.GT.MAXPTS) GO TO 560
      IF (EPS.LE.ZERO) GO TO 560
      IF (LENWRK.LT.2*NDIM+4) GO TO 560
      FUNCLS = 0
      FINVAL = ZERO
      ABSERR = ZERO
      TWONDM = TWO**NDIM
      RGNVOL = TWONDM
      DVFLAG = 1
      MAXAXS = IDINT(DMIN1(DFLOAT(X02BBF(ONE)),1.0D0/X02AAF(0.0D0)))
      MAXAXS = (MAXAXS-NDIM)/(NDIM+1)
      MXRGNS = LENWRK/(2*NDIM+4)
      SBRGNS = 0
      RGNVLT = ZERO
      RGNERT = ZERO
      DO 20 J=1,NDIM
         CENTER(J) = (A(J)+B(J))*HALF
         DIF(J) = ZERO
         WIDTH(J) = (B(J)-A(J))*HALF
         DVCNTL(J) = 1
         DVCNTR(J) = 1
         OLDCNT(J) = CENTER(J)
         RGNVOL = RGNVOL*WIDTH(J)
   20 CONTINUE
C
C       END SUBROUTINE INITIALISATION
C       BASIC RULE INITIALISATION
C
      RULCLS = 2**NDIM + 2*NDIM*NDIM + 2*NDIM + 1
      FUNCLS = RULCLS
      IF (MAXPTS.LT.RULCLS) GO TO 560
      RLNDIM = NDIM
      LAMDA2 = DSQRT(9.0D0/70.0D0)
      LAMDA4 = DSQRT(9.0D0/10.0D0)
      LAMDA5 = DSQRT(9.0D0/19.0D0)
      WEIT1 = (12824.0D0-9120.0D0*RLNDIM+400.0D0*RLNDIM*RLNDIM)/
     *19683.0D0
      WEIT2 = 980.0D0/6561.0D0
      WEIT3 = (1820.0D0-400.0D0*RLNDIM)/19683.0D0
      WEIT4 = 200.0D0/19683.0D0
      WEIT5 = 6859.0D0/19683.0D0/TWONDM
      WEITP1 = (729.0D0-950.0D0*RLNDIM+50.0D0*RLNDIM**2)/729.0D0
      WEITP2 = 245.0D0/486.0D0
      WEITP3 = (265.0D0-100.0D0*RLNDIM)/1458.0D0
      WEITP4 = 25.0D0/729.0D0
      RATIO = (LAMDA2/LAMDA4)**2
C
C       END BASIC RULE INITIALISATION
      GO TO 100
C       DIVIDE SUBREGION WITH LARGEST ERROR AND PREPARE TO USE
C       BASIC RULE ON EACH PORTION
C
   40 SUBRGN = 1
      POINTR = WRKSTR(1)
      RGNCLS = RULCLS
      RGNVOL = TWONDM
      TPONTR = POINTR + 2
      DO 60 J=1,NDIM
         TPONTR = TPONTR + 2
         CENTER(J) = WRKSTR(TPONTR-1)
         WIDTH(J) = WRKSTR(TPONTR)
         DVCNTR(J) = 1
         DVCNTL(J) = 1
         OLDCNT(J) = CENTER(J)
         RGNVOL = RGNVOL*WIDTH(J)
   60 CONTINUE
      DVAXES = WRKSTR(POINTR+2)
      IF (DVAXES.LT.0) GO TO 600
   80 DVAXIS = DVAXES
      DVAXES = DVAXIS/(NDIM+1)
      DVAXIS = DVAXIS - (NDIM+1)*DVAXES
      DVCNTL(DVAXIS) = 2*DVCNTL(DVAXIS)
      RGNCLS = RGNCLS*2
      IF (DVAXES.GT.0) GO TO 80
      IF (FUNCLS+RGNCLS.GT.MAXPTS) GO TO 580
      IF (RGNCLS/RULCLS+SBRGNS-1.GT.MXRGNS) DVFLAG = 2
      FUNCLS = FUNCLS + RGNCLS
      ABSERR = ABSERR - WRKSTR(POINTR)
      FINVAL = FINVAL - WRKSTR(POINTR+1)
C
C       BEGIN BASIC RULE
  100 DO 120 J=1,NDIM
         Z(J) = CENTER(J)
  120 CONTINUE
      SUM1 = FUNCTN(NDIM,Z)
      SUM2 = ZERO
      SUM3 = ZERO
      DO 140 J=1,NDIM
         Z(J) = CENTER(J) - LAMDA2*WIDTH(J)
         F1 = FUNCTN(NDIM,Z)
         Z(J) = CENTER(J) + LAMDA2*WIDTH(J)
         F2 = FUNCTN(NDIM,Z)
         Z(J) = CENTER(J) - LAMDA4*WIDTH(J)
         F3 = FUNCTN(NDIM,Z)
         Z(J) = CENTER(J) + LAMDA4*WIDTH(J)
         F4 = FUNCTN(NDIM,Z)
         SUM2 = SUM2 + F1 + F2
         SUM3 = SUM3 + F3 + F4
         DF1 = F1 + F2 - TWO*SUM1
         DF2 = F3 + F4 - TWO*SUM1
         DIF(J) = DIF(J) + CDABS(DF1-RATIO*DF2)
         Z(J) = CENTER(J)
  140 CONTINUE
      SUM4 = ZERO
      DO 200 J=2,NDIM
         Z(J-1) = CENTER(J-1) - LAMDA4*WIDTH(J-1)
         DO 160 K=J,NDIM
            Z(K) = CENTER(K) - LAMDA4*WIDTH(K)
            SUM4 = SUM4 + FUNCTN(NDIM,Z)
            Z(K) = CENTER(K) + LAMDA4*WIDTH(K)
            SUM4 = SUM4 + FUNCTN(NDIM,Z)
            Z(K) = CENTER(K)
  160    CONTINUE
         Z(J-1) = CENTER(J-1) + LAMDA4*WIDTH(J-1)
         DO 180 K=J,NDIM
            Z(K) = CENTER(K) - LAMDA4*WIDTH(K)
            SUM4 = SUM4 + FUNCTN(NDIM,Z)
            Z(K) = CENTER(K) + LAMDA4*WIDTH(K)
            SUM4 = SUM4 + FUNCTN(NDIM,Z)
            Z(K) = CENTER(K)
  180    CONTINUE
         Z(J-1) = CENTER(J-1)
  200 CONTINUE
      SUM5 = ZERO
      DO 220 J=1,NDIM
         Z(J) = CENTER(J) - LAMDA5*WIDTH(J)
  220 CONTINUE
  240 DO 260 J=2,NDIM
         IF (Z(J-1).LT.CENTER(J-1)+WIDTH(J-1)) GO TO 280
         Z(J-1) = CENTER(J-1) - LAMDA5*WIDTH(J-1)
         Z(J) = Z(J) + TWO*LAMDA5*WIDTH(J)
  260 CONTINUE
      IF (Z(NDIM).GT.CENTER(NDIM)+WIDTH(NDIM)) GO TO 300
  280 SUM5 = SUM5 + FUNCTN(NDIM,Z)
      Z(1) = Z(1) + TWO*LAMDA5*WIDTH(1)
      GO TO 240
  300 RGNVAL = RGNVOL*(WEIT1*SUM1+WEIT2*SUM2+WEIT3*SUM3+WEIT4*SUM4+
     *WEIT5*SUM5)
      RGNCMP = RGNVOL*(WEITP1*SUM1+WEITP2*SUM2+WEITP3*SUM3+WEITP4*SUM4)
      RGNERR = CDABS(RGNVAL-RGNCMP)
C
C       END BASIC RULE
C       STORE RESULTS OF BASIC RULE APPLICATION
C
      RGNVLT = RGNVLT + RGNVAL
      RGNERT = RGNERT + RGNERR
      FINVAL = FINVAL + RGNVAL
      ABSERR = ABSERR + RGNERR
      IF (DVFLAG.EQ.0) GO TO 340
      IF (DVFLAG.EQ.2) GO TO 500
      POINTR = MXRGNS + SBRGNS*(2*NDIM+3) + 1
      SBRGNS = SBRGNS + 1
      WRKSTR(SBRGNS) = POINTR
      SUBRGN = SBRGNS
      TPONTR = POINTR + 2
      DO 320 J=1,NDIM
         TPONTR = TPONTR + 2
         WRKSTR(TPONTR-1) = CENTER(J)
         WRKSTR(TPONTR) = WIDTH(J)
  320 CONTINUE
  340 WRKSTR(POINTR) = RGNERT
      WRKSTR(POINTR+1) = RGNVLT
C       DETERMINE AXIS ALONG WHICH FOURTH DIFFERENCE IS LARGEST
      DIFMAX = ZERO
      DO 380 J=1,NDIM
         IF (DIFMAX.GT.DIF(J)) GO TO 360
         DIFMAX = DIF(J)
         DVAXIS = J
  360    DIF(J) = ZERO
  380 CONTINUE
      TPONTR = POINTR + 2*(DVAXIS+1)
      WRKSTR(TPONTR) = WIDTH(DVAXIS)*HALF
      WRKSTR(TPONTR-1) = CENTER(DVAXIS) - WRKSTR(TPONTR)
      IF (DVFLAG.NE.2) GO TO 400
      DVAXES = WRKSTR(POINTR+2)
      IF (DVAXES.GT.MAXAXS) DVAXES = -1
      DVAXIS = DVAXIS + (NDIM+1)*DVAXES
  400 WRKSTR(POINTR+2) = DVAXIS
      IF (DVFLAG.EQ.1) GO TO 460
C       DETERMINE THE POSITION IN THE PARIALLY ORDERED LIST OF
C       THE SUBREGION WHICH REPLACES MOST RECENTLY DIVIDED SUBREGION
  420 SUBTMP = 2*SUBRGN
      IF (SUBTMP.GT.SBRGNS) GO TO 480
      TPONTR = WRKSTR(SUBTMP)
      IF (SUBTMP.EQ.SBRGNS) GO TO 440
      TPONTP = WRKSTR(SUBTMP+1)
      IF (DREAL(WRKSTR(TPONTR)).GE.DREAL(WRKSTR(TPONTP))) GO TO 440
      SUBTMP = SUBTMP + 1
      TPONTR = TPONTP
  440 IF (RGNERT.GE.DREAL(WRKSTR(TPONTR))) GO TO 480
      WRKSTR(SUBTMP) = POINTR
      WRKSTR(SUBRGN) = TPONTR
      SUBRGN = SUBTMP
      GO TO 420
C       WHEN WORKING STORAGE IS NOT USED UP, DETERMINE THE
C       POSITION IN THE PARTIALLY ORDERED LIST FOR THE DESCRIPTION
C       OF OTHER PORTION(S) OF MOST RECENTLY DIVIDED SUBREGION
  460 SUBTMP = SUBRGN/2
      IF (SUBTMP.LT.1) GO TO 480
      TPONTR = WRKSTR(SUBTMP)
      IF (RGNERT.LE.DREAL(WRKSTR(TPONTR))) GO TO 480
      WRKSTR(SUBTMP) = POINTR
      WRKSTR(SUBRGN) = TPONTR
      SUBRGN = SUBTMP
      GO TO 460
  480 RGNVLT = ZERO
      RGNERT = ZERO
      IF (DVFLAG.EQ.2) GO TO 540
      DVFLAG = 1 - DVFLAG
C       COUNT TO DETERMINE THE NEXT PART OF THE RECENTLY DIVIDED
C       SUBREGION FOR APPLICATION OF THE BASIC RULE
  500 CENTER(1) = CENTER(1) + TWO*WIDTH(1)
      DVCNTR(1) = DVCNTR(1) + 1
      DO 520 J=2,NDIM
         IF (DVCNTR(J-1).LE.DVCNTL(J-1)) GO TO 100
         DVCNTR(J-1) = 1
         CENTER(J-1) = OLDCNT(J-1)
         DVCNTR(J) = DVCNTR(J) + 1
         CENTER(J) = CENTER(J) + TWO*WIDTH(J)
  520 CONTINUE
      IF (DVCNTR(NDIM).LE.DVCNTL(NDIM)) GO TO 100
      CENTER(NDIM) = OLDCNT(NDIM)
      IF (DVFLAG.EQ.2) GO TO 340
C
C       END ORDERING OF BASIC RULE RESULTS
C       MAKE CHECKS FOR POSSIBLE TERMINATION OF ROUTINE
C
  540 ACC = ABSERR/CDABS(FINVAL)
      IF (ACC.GT.EPS .OR. FUNCLS.LT.MINPTS) GO TO 40
C
C       LOOP BACK TO APPLY BASIC RULE
C
C       TERMINATION POINT, SET IFAIL AND RETURN
C
      IERROR = 0
      GO TO 620
  560 IERROR = 1
      GO TO 620
  580 IERROR = 2
      GO TO 620
  600 IERROR = 3
  620 MINPTS = FUNCLS
      IFAIL = P01AAF(IFAIL,IERROR,SRNAME)
      RETURN
      END
C
      DOUBLE PRECISION FUNCTION X02AAF(X)
C     NAG COPYRIGHT 1975
C     MARK 4.5 RELEASE
      DOUBLE PRECISION X
C     * EPS *
C
C     IBM DOUBLE PRECISION VERSION
C
C     RETURNS THE VALUE EPS WHERE EPS IS THE SMALLEST
C     POSITIVE
C     NUMBER SUCH THAT 1.0 + EPS > 1.0
C     THE X PARAMETER IS NOT USED
C     FOR ICL 1900
C     X02AAF = 2.0**(-37.0)
C     FOR IBM 360/370
C     X02AAF = 2.0D0**(-52.0D0)
      DOUBLE PRECISION Z
      DATA Z/341000000/
      X02AAF = Z
      RETURN
      END
      INTEGER FUNCTION X02BBF(X)
C     NAG COPYRIGHT 1975
C     MARK 4.5 RELEASE
      DOUBLE PRECISION X
C     * MAXINT *
C
C     IBM DOUBLE PRECISION VERSION
C
C     RETURNS THE LARGEST INTEGER REPRESENTABLE ON THE COMPUTER
C     THE X PARAMETER IS NOT USED
C     FOR ICL 1900
C     X02BBF = 8388607
C     FOR IBM 360/370
      X02BBF = 2147483647
      RETURN
      END
      INTEGER FUNCTION P01AAF(IFAIL, ERROR, SRNAME)
C     MARK 1 RELEASE.  NAG COPYRIGHT 1971
C     MARK 3 REVISED
C     MARK 4A REVISED, IER-45
C     MARK 4.5 REVISED
C     MARK 7 REVISED (DEC 1978)
C     RETURNS THE VALUE OF ERROR OR TERMINATES THE PROGRAM.
      INTEGER ERROR, IFAIL, NOUT
C$P 1
      DOUBLE PRECISION SRNAME
C     TEST IF NO ERROR DETECTED
      IF (ERROR.EQ.0) GO TO 20
C     DETERMINE OUTPUT UNIT FOR MESSAGE
      CALL X04AAF (0,NOUT)
C     TEST FOR SOFT FAILURE
      IF (MOD(IFAIL,10).EQ.1) GO TO 10
C     HARD FAILURE
      WRITE (NOUT,99999) SRNAME, ERROR
C     STOPPING MECHANISM MAY ALSO DIFFER
      STOP
C     SOFT FAIL
C     TEST IF ERROR MESSAGES SUPPRESSED
   10 IF (MOD(IFAIL/10,10).EQ.0) GO TO 20
      WRITE (NOUT,99999) SRNAME, ERROR
   20 P01AAF = ERROR
      RETURN
99999 FORMAT (1H0, 38HERROR DETECTED BY NAG LIBRARY ROUTINE , A8,
     * 11H - IFAIL = , I5//)
      END
      SUBROUTINE X04AAF(I,NERR)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978
C     MARK 7C REVISED IER-190 (MAY 1979)
C     IF I = 0, SETS NERR TO CURRENT ERROR MESSAGE UNIT NUMBER
C     (STORED IN NERR1).
C     IF I = 1, CHANGES CURRENT ERROR MESSAGE UNIT NUMBER TO
C     VALUE SPECIFIED BY NERR.
C
C     *** NOTE ***
C     THIS ROUTINE ASSUMES THAT THE VALUE OF NERR1 IS SAVED
C     BETWEEN CALLS.  IN SOME IMPLEMENTATIONS IT MAY BE
C     NECESSARY TO STORE NERR1 IN A LABELLED COMMON
C     BLOCK /AX04AA/ TO ACHIEVE THIS.
C
C     .. SCALAR ARGUMENTS ..
      INTEGER I, NERR
C     ..
C     .. LOCAL SCALARS ..
      INTEGER NERR1
C     ..
      DATA NERR1 /6/
      IF (I.EQ.0) NERR = NERR1
      IF (I.EQ.1) NERR1 = NERR
      RETURN
      END